/* eslint-disable require-jsdoc */
/* eslint-disable no-undef */
(function libraryWrapper(window) {
  function defineLibrary() {
    const FiltersMapLib = {};

    FiltersMapLib.filterList = [
      VideoFiltersLib.AddFilter,
      VideoFiltersLib.DivideFilter,
      VideoFiltersLib.SubtractFilter,
      VideoFiltersLib.MultiplyFilter,
      VideoFiltersLib.AndFilter,
      VideoFiltersLib.OrFilter,
      VideoFiltersLib.XorFilter,
      VideoFiltersLib.CombineFilter,
      VideoFiltersLib.CombineWhiteFilter,
      VideoFiltersLib.SelectFilter,
      VideoFiltersLib.MixFilter,
      VideoFiltersLib.MaxFilter,
      VideoFiltersLib.MinFilter,
      VideoFiltersLib.QuadFilter,
      VideoFiltersLib.SliderFilter,
      VideoFiltersLib.VerticalSliderFilter,
      VideoFiltersLib.CameraFilter,
      VideoFiltersLib.BlurFilter,
      VideoFiltersLib.GaussianBlurFilter,
      VideoFiltersLib.MedianFilter,
      VideoFiltersLib.SharpenFilter,
      VideoFiltersLib.UnsharpenFilter,
  // VideoFiltersLib.DisplayFilter,
      VideoFiltersLib.DisplayFilter,
      VideoFiltersLib.VRDisplayFilter,
      VideoFiltersLib.EdgeDetectFilter,
      VideoFiltersLib.BlackFilter,
      VideoFiltersLib.WhiteFilter,
      VideoFiltersLib.GrayFilter,
      VideoFiltersLib.LensFilter,
      VideoFiltersLib.MirrorFilter,
      VideoFiltersLib.OvalFilter,
      VideoFiltersLib.ShutterFilter,
      VideoFiltersLib.RadialFilter,
      VideoFiltersLib.RepeaterFilter,
      VideoFiltersLib.RepeaterXFilter,
      VideoFiltersLib.RepeaterYFilter,
      VideoFiltersLib.RotateFilter,
      VideoFiltersLib.ScaleFilter,
      VideoFiltersLib.LowerScaleFilter,
      VideoFiltersLib.UpperScaleFilter,
      VideoFiltersLib.DrawEdgesFilter,
      VideoFiltersLib.NegativeFilter,
      VideoFiltersLib.BWFilter,
      VideoFiltersLib.DarkFilter,
      VideoFiltersLib.DilateFilter,
      VideoFiltersLib.DisplacementFilter,
      VideoFiltersLib.ErodeFilter,
      VideoFiltersLib.TriangleFilter,
      VideoFiltersLib.HexaFilter,
      VideoFiltersLib.PixelateFilter,
      VideoFiltersLib.PixelateNSFilter,
      VideoFiltersLib.GrayScaleFilter,
      VideoFiltersLib.BufferFilter,
      VideoFiltersLib.SamplerFilter,
      VideoFiltersLib.RGBFilter,
      VideoFiltersLib.RedFilter,
      VideoFiltersLib.GreenFilter,
      VideoFiltersLib.BlueFilter,
      VideoFiltersLib.ColorBandedFilter,
      VideoFiltersLib.Rule30Filter,
      VideoFiltersLib.LifeFilter,
      VideoFiltersLib.RasterizerFilter,
      VideoFiltersLib.HalftoneFilter,
      VideoFiltersLib.HalftoneColorFilter,
      VideoFiltersLib.VideoFilter,
      VideoFiltersLib.DynamicRandomNoiseFilter,
      VideoFiltersLib.StaticRandomNoiseFilter,
      VideoFiltersLib.TurbulentRandomNoiseFilter,
      VideoFiltersLib.ColorListFilter,
      VideoFiltersLib.ColorCageFilter,
      VideoFiltersLib.ColorMapFilter,
      VideoFiltersLib.MapColorFilter,
      VideoFiltersLib.ExpandColorsFilter,
      VideoFiltersLib.PaskaFilter,
      VideoFiltersLib.PaskempiFilter,
      VideoFiltersLib.FaceLensFilter,
      VideoFiltersLib.FaceSwapFilter,
      VideoFiltersLib.MouthSwapFilter,
  // scalar filterSelected
      ScalarFiltersLib.NumberFilter,
      ScalarFiltersLib.MaxScalarFilter,
      ScalarFiltersLib.MinScalarFilter,
      ScalarFiltersLib.AddScalarFilter,
      ScalarFiltersLib.SubtractScalarFilter,
      ScalarFiltersLib.MultiplyScalarFilter,
      ScalarFiltersLib.DivideScalarFilter,
      ScalarFiltersLib.MinusScalarFilter,
      ScalarFiltersLib.SineFilter,
      ScalarFiltersLib.SquareFilter,
      ScalarFiltersLib.SawFilter,
      ScalarFiltersLib.TriangleWaveFilter,
  // / colorlist filterSelected
      ColorListFiltersLib.RandomColorListFilter,
      ColorListFiltersLib.FaceDetectFilter,
      ColorListFiltersLib.MedianCutColorListFilter,
      ColorListFiltersLib.PastelColorListFilter,
      ColorListFiltersLib.RGBYColorListFilter,
      ColorListFiltersLib.FingerporiColorListFilter,
      ColorListFiltersLib.WumoColorListFilter,
      ColorListFiltersLib.C64ColorListFilter,
      ColorListFiltersLib.NESColorListFilter,
      ColorListFiltersLib.ShiftColorListFilter,
  // color filterSelected
      ColorFiltersLib.MaxColorFilter,
      ColorFiltersLib.MinColorFilter,
      ColorFiltersLib.RandomColorFilter,
      ColorFiltersLib.WhiteColorFilter
    ];

    FiltersMapLib.filterMap = {
      Add: VideoFiltersLib.AddFilter,
      Subtract: VideoFiltersLib.SubtractFilter,
      Multiply: VideoFiltersLib.MultiplyFilter,
      Divide: VideoFiltersLib.DivideFilter,
      And: VideoFiltersLib.AndFilter,
      Or: VideoFiltersLib.OrFilter,
      Xor: VideoFiltersLib.XorFilter,
      Combine: VideoFiltersLib.CombineFilter,
      CombineWhite: VideoFiltersLib.CombineWhiteFilter,
      Select: VideoFiltersLib.SelectFilter,
      Mix: VideoFiltersLib.MixFilter,
      Max: VideoFiltersLib.MaxFilter,
      Min: VideoFiltersLib.MinFilter,
      Quad: VideoFiltersLib.QuadFilter,
      Slider: VideoFiltersLib.SliderFilter,
      VerticalSlider: VideoFiltersLib.VerticalSliderFilter,
      Camera: VideoFiltersLib.CameraFilter,
      Display: VideoFiltersLib.DisplayFilter,
      VRDisplay: VideoFiltersLib.VRDisplayFilter,
      Blur: VideoFiltersLib.BlurFilter,
      GaussianBlur: VideoFiltersLib.GaussianBlurFilter,
      Median: VideoFiltersLib.MedianFilter,
      Sharpen: VideoFiltersLib.SharpenFilter,
      Unsharpen: VideoFiltersLib.UnsharpenFilter,
      Displacement: VideoFiltersLib.DisplacementFilter,
      Negative: VideoFiltersLib.NegativeFilter,
      EdgeDetect: VideoFiltersLib.EdgeDetectFilter,
      Black: VideoFiltersLib.BlackFilter,
      White: VideoFiltersLib.WhiteFilter,
      Gray: VideoFiltersLib.GrayFilter,
      Lens: VideoFiltersLib.LensFilter,
      Mirror: VideoFiltersLib.MirrorFilter,
      Oval: VideoFiltersLib.OvalFilter,
      Shutter: VideoFiltersLib.ShutterFilter,
      Radial: VideoFiltersLib.RadialFilter,
      Repeater: VideoFiltersLib.RepeaterFilter,
      RepeaterX: VideoFiltersLib.RepeaterXFilter,
      RepeaterY: VideoFiltersLib.RepeaterYFilter,
      Rotate: VideoFiltersLib.RotateFilter,
      Scale: VideoFiltersLib.ScaleFilter,
      LowerScale: VideoFiltersLib.LowerScaleFilter,
      UpperScale: VideoFiltersLib.UpperScaleFilter,
      DrawEdges: VideoFiltersLib.DrawEdgesFilter,
      BW: VideoFiltersLib.BWFilter,
      Dark: VideoFiltersLib.DarkFilter,
      Dilate: VideoFiltersLib.DilateFilter,
      Erode: VideoFiltersLib.ErodeFilter,
      Triangle: VideoFiltersLib.TriangleFilter,
      Hexa: VideoFiltersLib.HexaFilter,
      Pixelate: VideoFiltersLib.PixelateFilter,
      PixelateNS: VideoFiltersLib.PixelateNSFilter,
      GrayScale: VideoFiltersLib.GrayScaleFilter,
      Buffer: VideoFiltersLib.BufferFilter,
      Sampler: VideoFiltersLib.SamplerFilter,
      RGB: VideoFiltersLib.RGBFilter,
      Red: VideoFiltersLib.RedFilter,
      Green: VideoFiltersLib.GreenFilter,
      Blue: VideoFiltersLib.BlueFilter,
      ColorBanded: VideoFiltersLib.ColorBandedFilter,
      Rule30: VideoFiltersLib.Rule30Filter,
      Life: VideoFiltersLib.LifeFilter,
      Rasterizer: VideoFiltersLib.RasterizerFilter,
      Halftone: VideoFiltersLib.HalftoneFilter,
      HalftoneColor: VideoFiltersLib.HalftoneColorFilter,
      Video: VideoFiltersLib.VideoFilter,
      DRN: VideoFiltersLib.DynamicRandomNoiseFilter,
      SRN: VideoFiltersLib.StaticRandomNoiseFilter,
      TRN: VideoFiltersLib.TurbulentRandomNoiseFilter,
      ColorList: VideoFiltersLib.ColorListFilter,
      ColorCage: VideoFiltersLib.ColorCageFilter,
      ColorMap: VideoFiltersLib.ColorMapFilter,
      MapColor: VideoFiltersLib.MapColorFilter,
      ExpandColors: VideoFiltersLib.ExpandColorsFilter,
      Paska: VideoFiltersLib.PaskaFilter,
      Paskempi: VideoFiltersLib.PaskempiFilter,
      FaceLens: VideoFiltersLib.FaceLensFilter,
      FaceSwap: VideoFiltersLib.FaceSwapFilter,
      MouthSwap: VideoFiltersLib.MouthSwapFilter,
  // scalar filters
      Number: ScalarFiltersLib.NumberFilter,
      MaxScalar: ScalarFiltersLib.MaxScalarFilter,
      MinScalar: ScalarFiltersLib.MinScalarFilter,
      AddScalar: ScalarFiltersLib.AddScalarFilter,
      SubtractScalar: ScalarFiltersLib.SubtractScalarFilter,
      MultiplyScalar: ScalarFiltersLib.MultiplyScalarFilter,
      DivideScalar: ScalarFiltersLib.DivideScalarFilter,
      MinusScalar: ScalarFiltersLib.MinusScalarFilter,
      Sine: ScalarFiltersLib.SineFilter,
      Square: ScalarFiltersLib.SquareFilter,
      Saw: ScalarFiltersLib.SawFilter,
      TriangleWave: ScalarFiltersLib.TriangleWaveFilter,
  // color list filterSelected
      RandomColorList: ColorListFiltersLib.RandomColorListFilter,
      FaceDetect: ColorListFiltersLib.FaceDetectFilter,
      MedianCutColorList: ColorListFiltersLib.MedianCutColorListFilter,
      PastelColorList: ColorListFiltersLib.PastelColorListFilter,
      RGBYColorList: ColorListFiltersLib.RGBYColorListFilter,
      C64ColorList: ColorListFiltersLib.C64ColorListFilter,
      FingerporiColorList: ColorListFiltersLib.FingerporiColorListFilter,
      WumoColorList: ColorListFiltersLib.WumoColorListFilter,
      NESColorList: ColorListFiltersLib.NESColorListFilter,
      ShiftColorList: ColorListFiltersLib.ShiftColorListFilter,

  //  color filters
      MaxColor: ColorFiltersLib.MaxColorFilter,
      MinColor: ColorFiltersLib.MinColorFilter,
      RandomColor: ColorFiltersLib.RandomColorFilter,
      WhiteColor: ColorFiltersLib.WhiteColorFilter
    };

    return FiltersMapLib;
  }
  if (typeof (FiltersMapLib) === 'undefined') window.FiltersMapLib = defineLibrary(); // eslint-disable-line no-param-reassign, no-undef
  else console.log('Library already defined.'); // eslint-disable-line no-console
}(window)); // eslint-disable-line no-undef
